unit BoxAPI;

// Swithed Command_HWND to LsExecuteEX
// Added a Tinting Function
// Wrote A new GetToken funktion to fix the Issue with Tab
Interface
Uses
  Windows,
  MyTypes;

Type
  PBlendFunction = ^TBlendFunction;
  TBlendFunction = Record
                     BlendOp,
                     BlendFlags,
                     SourceConstantAlpha,
                     AlphaFormat: Byte;
                   End;

function AnimateWindow(hWnd: HWND; dwTime: DWORD; dwFlags: DWORD): Boolean; stdcall; external user32dll;

//GDI AlphaTransparency Functions
function UpdateLayeredWindow(hWnd : hWnd; hdcDst : hDC; pptDst : PPoint; psize : PSize;
                             hdcSrc : hDC; pptSrc : PPoint; crKey : TColorRef;
                             pblend : PBlendFunction; dwFlags : Integer) : Integer; StdCall; external user32dll;
function SetLayeredWindowAttributes(hWnd, crKey : LongInt;
                                    Alpha : Byte; dwFlags : LongInt) : Boolean; stdcall; external user32dll;

function GetShortPathName(lpszLongPath: PChar; lpszShortPath: PChar; cchBuffer: DWORD): DWORD; stdcall;

procedure DragAcceptFiles(Wnd: HWND; Accept: BOOL); stdcall; external shell32;
procedure DragFinish(Drop: HDROP); stdcall; stdcall; external shell32;
function DragQueryFile(Drop: HDROP; FileIndex: UINT; FileName: PChar; cb: UINT): UINT; stdcall; external shell32;

function UpStr(Str: String): String;
function StrAlloc(Size: Cardinal): PChar;
procedure StrDispose(Str: PChar);
function StrRScan(Str: PChar; Chr: Char): PChar; assembler;
function GetLSPath: String;
function ExpandFileName(const FileName: string): string;
Function GetBoxFromWnd(Box: PBox; Wnd: Integer): PBox;
Function GetToken(Args: String;n: Byte): String;
Function CommandToken(Args: String;n: Byte): String;
function GetTokenEx(TokenStr: String;LeftQChr, RightQChr: Char; TokenNr: integer): String;
Function Int2Str(Value: Integer): String;
Function Str2Int(S: string): Integer;
Function Str2Hex(Str: String): LongInt;
Function Normalize(a,b: integer): integer;

Procedure SetWindowRgnEx(hWnd: HWND; Rgn_0: HRGN);
Function _TrackMouseEvent(var EventTrack: TTrackMouseEvent): Boolean; stdcall; external 'Comctl32.dll';

Procedure CreateHint(Wnd: Hwnd;Txt: Pchar);
Procedure RemoveHint(Wnd: HWND);
Procedure CreateCommandWnd;
Procedure DestroyCommandWnd;

Function GetFlag(Flags,Flag: Word): Boolean;
Procedure SetFlag(Var Flags: Word; Flag: Word; State: Boolean);
Function GetGroup(Flags: String): Integer;
Function CheckFlag(Flags:String; Flag:Char):byte;

Procedure BuildBackground(PatternBMP: HBitmap; LeftOffs, TopOffs,
                          RightOffs, BottomOffs: integer; RefWnd: Hwnd;
                          DestDC: HDc; dWidth, dHeight: integer);

Function VarExpansion(Str: String): String;

Function AddGroupItem(GWnd: HWND; Id: Integer): PGroupItem;
Procedure SetGroupState(Group: PGroup;State: integer);
Procedure AllignGroup(Group: PGroup);

Function GetBoxFromName(BoxName: String): PBox;

procedure MoveRect(Rect: PRect; xPos, yPos: integer);

Procedure MsgBox(Flags: integer; Msg: String);

Procedure MoveDockedBoxes(Box: PBox);

//Litestep API Functions
function LSExecuteEx(Owner: HWND; szOperation, szCommand, szArgs, szDirectory: AnsiString; nShowCmd: integer): integer; cdecl; external lsapidll;
function LSExecute(Owner: HWND;szCommand: AnsiString;nShowCmd: boolean):integer; cdecl; external lsapidll;
function LoadLSImage (szImage, szFile: PChar): HBitmap; cdecl; external lsapidll;
Function AddBangCommand(command: string; f: Pointer): Boolean; cdecl; external lsapidll;
Function RemoveBangCommand(command: string): Boolean; cdecl; external lsapidll;
Procedure GetLSBitmapSize(hBitmap: HBitmap;Var x, y: Integer); cdecl; external lsapidll;
Function BitmapToRegion (hBmp: hbitmap;cTransparentColor, cTolerance: Integer;xoffset, yoffset: Integer): HRGN; cdecl; external lsapidll;
Function LCReadNextConfig(F: integer; szPrefix,szBuffer : Pchar; dwLength: integer): Boolean; cdecl; external lsapidll;
Function LCOpen(szPath: PChar): Integer; cdecl; external lsapidll;
Function LCClose(F: integer): Boolean; cdecl; external lsapidll;
procedure VarExpansionA(Buffer: PChar; Value: PChar); cdecl; external lsapidll name 'VarExpansion';
function GetLitestepWnd:HWND; cdecl; external lsapidll;

Implementation

procedure InitCommonControls; stdcall; external 'comctl32.dll';

function GetShortPathName; external 'kernel32.dll' name 'GetShortPathNameA';

Function Pot(b,e: integer):LongInt;
Begin
  If (e<=0) then
    Pot := 1
  Else
    Pot := b * Pot(b,e-1);
End;

function Trim(const S: string): string;
var
  a,e: integer;
Begin
  a := 1; e := length(S);
  while ((a<=e)and(S[a] <= #32)) do inc(a);
  if (a > e) then Result := '' else
  Begin
    while ((a<=e) and (S[e] <= #32)) do dec(e);
    Result := Copy(S,a,e-a+1);
  End;
End;

function TrimLeft(const S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= #32) do Inc(I);
  Result := Copy(S, I, Maxint);
end;

function TrimRight(const S: string): string;
var
  I: Integer;
begin
  I := Length(S);
  while (I > 0) and (S[I] <= #32) do Dec(I);
  Result := Copy(S, 1, I);
end;

Function UpStr(Str: String): String;
Var
  Pos: Integer;
  UStr: String;
Begin
  UStr := Str;
  For Pos := 1 to length(UStr) Do
    if (UStr[pos] >= 'a') and (UStr[pos] <= 'z') then Dec(UStr[pos], 32);
  Result := UStr;
End;

Function StrAlloc(Size: Cardinal): PChar;
begin
  Inc(Size, SizeOf(Cardinal));
  GetMem(Result, Size);
  Cardinal(Pointer(Result)^) := Size;
  Inc(Result, SizeOf(Cardinal));
end;

Procedure StrDispose(Str: PChar);
begin
  if Str <> nil then
  begin
    Dec(Str, SizeOf(Cardinal));
    FreeMem(Str, Cardinal(Pointer(Str)^));
  end;
end;

function StrLen(tStr:PChar):integer;  // assembler version
asm
      MOV     EDX,7
      ADD     EDX,EAX                   { pointer+7 used in the end }
      PUSH    EBX                       { is necessary; even in your version}
      MOV     EBX,[EAX]                 { read first 4 bytes}
      ADD     EAX,4                     { increment pointer}
@L1:  LEA     ECX,[EBX-$01010101]       { subtract 1 from each byte}
      XOR     EBX,-1                    { invert all bytes}
      AND     ECX,EBX                   { and these two}
      MOV     EBX,[EAX]                 { read next 4 bytes}
      ADD     EAX,4                     { increment pointer}
      AND     ECX,80808080H             { test all sign bits}
      JZ      @L1                       { no zero bytes, continue loop}
      TEST    ECX,00008080H             { test first two bytes}
      JNZ     @L2                       { *was JNZ SHORT @L2*}
      SHR     ECX,16                    { not in the first 2 bytes}
      ADD     EAX,2
@L2:  SHL     CL,1                      { use carry flag to avoid a branch}
      POP     EBX                       { Likewise; see above}
      SBB     EAX,EDX                   { compute length}
end;

function StrCopy(Dest, Source: PChar): PChar; assembler;
asm
        PUSH    EDI
        PUSH    ESI
        MOV     ESI,EAX
        MOV     EDI,EDX
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        MOV     EDI,ESI
        MOV     ESI,EDX
        MOV     EDX,ECX
        MOV     EAX,EDI
        SHR     ECX,2
        REP     MOVSD
        MOV     ECX,EDX
        AND     ECX,3
        REP     MOVSB
        POP     ESI
        POP     EDI
end;

function StrRScan(Str: PChar; Chr: Char): PChar; assembler;
asm
        PUSH    EDI
        MOV     EDI,Str
        MOV     ECX,0FFFFFFFFH
        XOR     AL,AL
        REPNE   SCASB
        NOT     ECX
        STD
        DEC     EDI
        MOV     AL,Chr
        REPNE   SCASB
        MOV     EAX,0
        JNE     @@1
        MOV     EAX,EDI
        INC     EAX
@@1:    CLD
        POP     EDI
end;

Function GetLSPath: String;
Var
  PC: PChar;
  e: Integer;
Begin
  PC := StrAlloc(256);
  GetModuleFileName(GetWindowLong(FindWindow('TApplication', 'LiteStep'), GWL_HINSTANCE),PC,255);
  E := Length(PC);
  While ( PC[e] <> '\' )AND( E > 0 ) Do Dec(E);
    Result := Copy(PC,1,e);
  StrDispose(PC)
End;

function ExpandFileName(const FileName: string): string;
var
  FName: PChar;
  Buffer: array[0..MAX_PATH - 1] of Char;
begin
  SetString(Result, Buffer, GetFullPathName(PChar(FileName), SizeOf(Buffer),
    Buffer, FName));
end;

Function GetBoxFromWnd(Box: PBox; Wnd: Integer): PBox;
Begin
  If (Box^.Next_Box = nil) OR (Box^.hMainWnd = Wnd) then
    GetBoxFromWnd := Box
  Else
    GetBoxFromWnd := GetBoxFromWnd(Box^.Next_Box, Wnd);
End;

function GetToken(args: String;n: Byte): String;
var
  a,e,i : integer;
  ch: char;
begin
  e := 0;a := 0;
  for i := 1 to n do
  begin
    a := e+1;
    ch := #32;
    while ((args[a] in [ch,#9])and(args[a]<>#0)) do inc(a);
    If (args[a]=#34) then begin
      inc(a); ch := #34; end;
    e := a;
    while not(args[e] in [ch,#0]) do inc(e);
  end;
  if (e>a) then
    begin
      //if (args[e+1] = #34) then dec(e);
      Result := Copy(args,a,e-a);
    end
  else
    Result := '';
end;

Function CommandToken(Args: String;n: Byte): String;
var
  a,e,i : integer;
  ch: char;
begin
  a := 0; e := 0;
  for i := 1 to n do
  begin
    a := e+1;
    ch := #32;
    while ((args[a] in [ch,#9])and(args[a]<>#0)) do inc(a);
    e := a;
    If (args[a]=#34) then
      begin
        ch := #34;
        inc(e);
      end;
    while not(args[e] in [ch,#0]) do inc(e);
  end;
  if (e>a) then
    Result := Copy(Args,a,MAX_LINE_LENGTH)
  else
    Result := '';
end;

function GetTokenEx(TokenStr: String;LeftQChr, RightQChr: Char; TokenNr: integer): String;
var
  StrAPos,StrEPos,CurrentToken,L: integer;
begin
  CurrentToken := 0;
  StrAPos := 1;
  StrEPos := 1;
  L := Length(TokenStr);
  While TokenNr>CurrentToken do
   begin
     StrAPos := StrEPos;
     While (L>StrAPos)AND
           (TokenStr[StrAPos]<>LeftQChr)Do Inc(StrAPos);
     StrEPos := StrAPos + 1;
     While (L>StrEPos)AND
           (TokenStr[StrEPos]<>RightQChr)Do Inc(StrEPos);
     Inc(CurrentToken)
   end;
  Result := Copy(TokenStr,StrAPos+1,(StrEPos-StrAPos)-1);
end;

Function Int2Str(Value: Integer): String;
Begin
  If (value<0) then
    Int2Str := '~'+Int2Str(Value*(-1))
  else
    If not((Value DIV 10) = 0) then
      result := Int2Str(Value DIV 10) + Chr(48 + (Value MOD 10))
    else
      result := Chr(48 + (Value Mod 10));
end;

function Str2Int(s: String): Integer;
var
  i,c : integer;
  neg,rel : boolean;
begin
  c := 0;neg := false;rel := false;
  for i := length(s)-1 downto 0 do
   begin
    case s[i+1] of
      '-' : neg := true;
      '~' : rel := true;
    end;
    if ( Ord(s[i+1]) in [48..57] ) then
      c := c + ( (ord(s[i+1])-48)*Pot(10,length(s)-i-1) );
   end;

  if ( rel ) then // Its a "real Negative number"
    Str2Int := c + 45255
  else
    if ( neg ) then
      if ( c=0 ) then
        Str2Int := 45255 //Magic Number for "-0"
      else //its a negative number
        Str2Int := c*(-1)
    else //a Positive number
      Str2Int := c;
End;

Function Str2Hex(Str: String): LongInt;

  Function Rek(Str: String; pos: Integer): LongInt;
  Var
    c: Char;
   Begin
     Rek := 0;
     If Pos<>Length(Str) Then
     Begin
       C := Str[Length(Str)-pos];
       If (Ord(C)>47)AND(Ord(C)<58) Then
         Rek := Rek(Str,Pos+1)+((Ord(C)-48)*Pot(16,Pos))
       Else
         If (Ord(C)>64)AND(Ord(C)<71) Then
           Rek := Rek(Str,Pos+1)+((Ord(C)-55)*Pot(16,Pos)) ;
     End
   End;

Begin
  Str2Hex := Rek(UpStr(Str),0);
End;

Function Normalize(a,b: integer): integer;
begin
  if ( a<0 ) then
    Normalize := b+a
  else
    if ( a=45255 ) then //Magic Number for -0
      Normalize := b
    else
      if ( a>45255 ) then
        Normalize := (a-45255)*(-1)
      else
        Normalize := a;
end;

Procedure SetWindowRgnEx(hWnd: HWND; Rgn_0: HRGN);
Var
  windowRgn: HRGN;
Begin
  windowRgn := CreateRectRgn(0, 0, 0, 0);
  CombineRgn(windowRgn, Rgn_0, 0, RGN_COPY);
  SetWindowRgn(hWnd, windowRgn, true);
End;

Procedure CreateHint(Wnd: Hwnd;Txt: Pchar);
Const
  TTM_ADDTOOL = WM_USER + 4;
Var
  Ti: TToolInfo;
Begin
  If Hint_HWND=0 Then
  Begin
    InitCommonControls;
    Hint_HWND := CreateWindowEx(0,
       'Tooltips_class32', nil, TTS_ALWAYSTIP,
       CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
       CW_USEDEFAULT, 0, 0, hinstance, nil);
    If Hint_HWND=0 then
      MessageboxA(0,'Error Creating Tooltip Control',nil,0);
    SetWindowPos(Hint_HWND,HWND_TOPMOST,CW_USEDEFAULT,
      CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,SWP_NOMOVE+SWP_NOSIZE+SWP_NOACTIVATE);
  end;
  Ti.cbSize := SizeOf(TToolInfo);
  Ti.uFlags := TTF_SUBCLASS;
  Ti.hInst := hInstance;
  Ti.hwnd := wnd;
  Ti.uId := 0;
  GetClientRect(Wnd, Ti.rect);
  Ti.lpszText := txt;
  SendMessage(Hint_HWND,TTM_ADDTOOL,0,Integer(@Ti))
End;

Procedure RemoveHint(Wnd: HWND);
Var
  Ti: TToolInfo;

Begin
  ti.cbSize := sizeof(TTOOLINFO);
  ti.uFlags := 0;
  ti.hwnd := Wnd;
  ti.hinst := hInstance;
  ti.uId := 0;
  ti.lpszText := Nil;
  SendMessage(Hint_HWND,TTM_DELTOOL,0,Integer(@Ti));
End;

Function Command_WndProc(Wnd, Msg: Integer; wParam, lParam: Longint): Longint; stdcall;
Var
  Buffer: PChar;
Begin
  Command_WndProc := 0;
  Case Msg Of
     BM_COMMAND:
       LSExecuteEx(GetDesktopWindow, '', GetToken(PChar(lparam),1), CommandToken(PChar(lparam),2), '', SW_SHOWNORMAL);
     LM_GETREVID:  // Get our revision for '!About detailed'
       begin
         Buffer := PChar(lParam);
         if (wParam=0) then
           StrCopy(Buffer,PChar('LsBox.dll: '+revision))
         else if (wParam=1) then
           StrCopy(Buffer,revId)
         else
           StrCopy(Buffer,'');
         result:=StrLen(Buffer);
      end;
     Else
       Command_WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
  End;
End;

Procedure CreateCommandWnd;
Var
  Msgs:array [0..1] of longint;
  wc: Twndclass;
Begin
  If NOT GetClassInfo(Inst,'CommandClass',wc) then
  Begin
    FillChar(wc,sizeof(wc), #0);
    wc.lpfnWndProc := @Command_WndProc;
    wc.lpszClassName := 'CommandClass';
    wc.hInstance := Inst;
    RegisterClassA(wc);
  End;
  Command_HWND := CreateWindowExA(
      WS_EX_TOOLWINDOW,'CommandClass','',WS_POPUP,
      0,0,0,0,0,0,Inst,nil);

  Msgs[0] := LM_GETREVID;
  Msgs[1] := 0;
  SendMessage(GetLitestepWnd, LM_REGISTERMESSAGE, Command_HWND, Integer(@Msgs));
End;

Procedure DestroyCommandWnd;
Var
  Msgs:array [0..1] of longint;
  wc: Twndclass;
Begin
  Msgs[0] := LM_GETREVID;
  Msgs[1] := 0;
  SendMessage(GetLitestepWnd, LM_UNREGISTERMESSAGE, Command_HWND, Integer(@Msgs));
  DestroyWindow(Command_HWND);
  If GetClassInfo(Inst,'CommandClass',wc) then
    UnregisterClass('CommandClass',Inst);
End;

Function GetFlag(Flags,Flag: Word): Boolean;
Begin
  GetFlag := (Flags AND Flag = Flag);
End;

Procedure SetFlag(Var Flags: Word; Flag: Word; State: Boolean);
Begin
  If State Then
    Flags := (Flags OR Flag)
  Else
    Flags := (Flags And Not Flag)
End;

Function CheckFlag(Flags:String; Flag:Char):byte;
Var
  i: integer;
Begin
  CheckFlag := 0;
  For i:= 1 to Length(Flags) do
    If ( UpCase(Flags[i])=Flag ) Then
      CheckFlag := i;
End;


Function GetGroup(Flags: String): Integer;
Var
  b,e: integer;
Begin
    b := CheckFlag(Flags,'#');
    If Boolean(b) then
    Begin
      e := b+1;
      While (e<Length(Flags))AND(Flags[e+1]<':')AND(Flags[e+1]>'/') do Inc(e);
      Result := Str2Int( Copy(Flags,b+1,e-1) );
    End Else
      Result := 0;
End;


Procedure BuildBackground(PatternBMP: HBitmap; LeftOffs, TopOffs,
                          RightOffs, BottomOffs: integer; RefWnd: Hwnd;
                          DestDC: HDc; dWidth, dHeight: integer);
Var
  RefDC,
  TempDC: HDc;
  TempBMP: HBitmap;
  pWidth,pHeight,
  x,y,xSize,ySize: integer;

Begin
  RefDC := GetDC(RefWnd);
  TempDC := CreateCompatibleDC(RefDC);
  TempBMP := CreateCompatibleBitmap(RefDC,dWidth,dHeight);
  ReleaseDC(RefWnd,RefDC);

  GetLSBitmapSize(PatternBMP,pWidth,pHeight);

  SelectObject (TempDC,PatternBMP);
  SelectObject (DestDC,TempBMP);

  xSize := (pWidth - (LeftOffs + RightOffs));
  ySize := (pHeight - (TopOffs + BottomOffs));

  //do the magic optimized for Width>Height

     y := 0;//bcount := 2;
     BitBlt(DestDC,0,TopOffs,LeftOffs,ySize,TempDC,0,TopOffs,SRCCOPY);
     BitBlt(DestDC,LeftOffs,TopOffs,xSize,ySize,TempDC,LeftOffs,TopOffs,SRCCOPY);
     //Paint the Main Background and the Left Edge
     While (Pot(2,y)*ySize < (dHeight)) do
       begin
         BitBlt(DestDC,0,(Pot(2,y)*ySize)+TopOffs,xSize+LeftOffs,Pot(2,y)*ySize,DestDC,0,TopOffs,SRCCOPY);
         inc(y);//inc(bcount);
       end;
     //MsgBox(0,Int2Str(y)+':'+Int2Str(ySize));

     x := 0;//inc(bcount,2);
     // TopLeft corner & Top edge
     BitBlt(DestDC, 0, 0, xSize+LeftOffs, TopOffs, TempDC, 0, 0,SRCCOPY);
     // BottomLeft Corner & Bottom edge
     BitBlt(DestDC, 0, dHeight-BottomOffs, xSize+LeftOffs, BottomOffs, TempDC, 0, pHeight-BottomOffs,SRCCOPY);
     //Paint The Top, Bottom Edges and Fill the Center
     While (Pot(2,x)*xSize < (dwidth-RightOffs)) do
     begin
       BitBlt(DestDC,(Pot(2,x)*xSize)+LeftOffs,0,(Pot(2,x)*xSize),dheight,DestDC,LeftOffs,0,SRCCOPY);
       inc(x);//inc(bcount);
     end;
     //MsgBox(0,Int2Str(x)+':'+Int2Str(xSize));

     y := 0;//inc(bcount,2);
     //RightTop Corner & Right Border
     BitBlt(DestDC,dWidth-RightOffs,0,RightOffs,TopOffs+ysize,TempDC,pWidth-RightOffs,0,SRCCOPY);
     While (Pot(2,y)*ySize < (dHeight)) do
       begin
         BitBlt(DestDC,dWidth-RightOffs,(Pot(2,y)*ySize)+TopOffs,xSize+LeftOffs,Pot(2,y)*ySize,DestDC,dWidth-RightOffs,TopOffs,SRCCOPY);
         inc(y);//inc(bcount);
       end;
     //finally paint the BottomRight corner
     BitBlt(DestDC,dWidth-RightOffs,dHeight-BottomOffs,RightOffs,BottomOffs,TempDC,pWidth-RightOffs,pHeight-BottomOffs,SRCCOPY);
     //MsgBox(0,Int2Str(bcount)+' mal bitblt');

  DeleteDc(TempDC);

  DeleteObject(TempBMP);

End;

Function VarExpansion(Str: String): String;
Var
  StrTmp: PChar;
Begin
  StrTmp := StrAlloc(4096);
  VarExpansionA(StrTmp,PChar(Str));
  VarExpansion := String(StrTmp);
  StrDispose(StrTmp);
End;

Function AddGroupItem(GWnd: HWND; Id: Integer): PGroupItem;
Var
  Group: PGroup;
  GroupItem: PGroupItem;

  Function SeekGroup(id: Integer): Pointer;
  Var
    Group: PGroup;
  Begin
    Group := First_Group;
    While ((Group<>nil)AND(Group^.id<>id)) Do
      Group := Group^.Next_Group;
    If (Group=nil) Then
     Begin
      New(Group);
      Group^.Next_Group := First_Group;
      Group^.Prev_Group := nil;
      If Group^.Next_Group<>nil then
        Group^.Next_Group^.Prev_Group := Group;
      Group^.First_Item := nil;
      First_Group := Group;
      Group^.id := id;
      Group^.Flags := 0;
     End;
  SeekGroup := Group;
End;


Begin
  Group := SeekGroup(id);
  New(GroupItem);
  GroupItem^.Wnd := GWnd;
  GroupItem^.Group := Group;
  GroupItem^.Next_Item := Group^.First_Item;
  GroupItem^.Prev_Item := nil;
  If GroupItem^.Next_Item<>nil then
    GroupItem^.Next_Item^.Prev_Item := GroupItem;
  Group^.First_Item := GroupItem;
  AddGroupItem := GroupItem;
End;

Procedure SetGroupState(Group: PGroup;State: integer);
Var
  GroupItem: PGroupItem;
  Rect: TRect;
Begin
  If ( Group<>nil ) Then
  Begin
    GroupItem := Group^.First_Item;
    While (GroupItem<>nil) do
    Begin
      ShowWindow(GroupItem^.Wnd,State);
      GetWindowRect(GroupItem^.Wnd,Rect);
      if (State=SW_HIDE) then
        InvalidateRect(GetParent(GroupItem^.Wnd),@Rect,true)
      else
        Invalidatergn(GroupItem^.Wnd,0,true);
      GroupItem := GroupItem^.Next_Item;
    End;
  End;
End;

Procedure AllignGroup(Group: PGroup);
Var
  GroupItem: PGroupItem;
Begin
  If ( Group<>nil ) Then
  Begin
    GroupItem := Group^.First_Item;
    While (GroupItem<>nil) do
    Begin
      PostMessage(GroupItem^.Wnd,WM_SHOWWINDOW,1,0);
      InvalidateRect(GroupItem^.Wnd,nil,false);
      GroupItem := GroupItem^.Next_Item;
    End;
  End;
End;


Function GetBoxFromName(BoxName: String): PBox;
Var
  Box: PBox;
Begin
  Box := First_Box;
  BoxName := UpStr(GetToken(BoxName,1));
  While ( Box<>nil )AND( UpStr(Box^.title)<>BoxName ) Do
    Box := Box^.Next_Box;
 If (Box=nil) then
   Msgbox(MB_ICONWARNING,'Box "'+BoxName+'" not Found!');
 GetBoxFromName := Box;
End;

procedure MoveRect(Rect: PRect; xPos, yPos: integer);
begin
  Rect.right := xPos+(Rect.right-Rect.left);
  Rect.left := xPos;
  Rect.bottom := yPos+(Rect.bottom-Rect.top);
  Rect.top := yPos;
end;

Procedure MsgBox(Flags: integer; Msg: String);
begin
  MessageBoxEx(0,PChar(Msg),'LsBox Error',Flags,0);
end;

Procedure MoveDockedBoxes(Box: PBox);
Var
  DockedBox: PDockedBox;
begin
  With Box^ do
   begin
     If (First_DockedBox<>nil)Then
      begin
        DockedBox := First_DockedBox;
        While (DockedBox<>nil) do
         begin
           SendMessage(DockedBox.fBox.hMainWnd,BM_MOVEBOX,Box^.yPos-DockedBox.yoffs,Box^.xPos-DockedBox.xoffs);
           DockedBox := DockedBox.Next_DockedBox;
         end;
      end;
   end;
end;

begin
  //Get LiteStep Desktop
  LSDskWnd := FindWindow('DesktopBackgroundClass','DesktopBackgroundClass');
  LSDskWnd := GetNextWindow(LSDskWnd,GW_HWNDPREV);
  //Set the Screen Resolution
  ScreenX := GetSystemMetrics(SM_CXSCREEN);
  ScreenY := GetSystemMetrics(SM_CYSCREEN);
end.