library LsBox;


uses
  Windows,
  Boxes in 'Boxes.pas',
  BoxFiles in 'BoxFiles.pas',
  Shortcuts in 'Shortcuts.pas',
  Modules in 'Modules.pas',
  BoxAPI in 'BoxAPI.pas',
  WharfModules in 'WharfModules.pas',
  Bangs in 'Bangs.pas',
  MyTypes in 'MyTypes.pas',
  ModuleHooks in 'ModuleHooks.pas',
  Loadmodules in 'Loadmodules.pas';

Function initModuleEx(ParentWnd:Integer;dllInst:Longint;szPath:PCHAR):longint; cdecl;
Var
  Buffer: PChar;
  RC: Integer;
Begin
  Parent_Wnd := ParentWnd;
  Inst := dllInst;
  CreateCommandWnd;
  LsPath := GetLSPath;
  
  RegisterBangs;

  Buffer := StrAlloc(MAX_LINE_LENGTH);
  Rc:=LCOpen(nil);

  While LCReadNextConfig(Rc,'*LsBoxCreate',buffer,MAX_LINE_LENGTH) Do
    Begin
      BuildBox(GetToken(Buffer,2),0);
    End;

  LCClose(rc);
  StrDispose(Buffer);

  initModuleEx := 0;
End;

Procedure quitModule(dllInst:Longint); cdecl;
Var
  Wc: TWndClass;
  Group: PGroup;

Begin
  UnRegisterBangs;

  While ( First_Box<>nil ) Do
   begin
     SetFlag(First_Box^.Flags,isDocked,false);
     DestroyWindow(First_Box^.hMainWnd);
     DestroyBox(First_Box);
   end;

  Group := First_Group;
  While ( Group<>nil ) Do
  Begin
    First_Group := Group^.Next_Group;
    Dispose (Group);
    Group := First_Group;
  End;

  If GetClassInfo(Inst,'LsBoxClass',wc) then
    UnregisterClass('LsBoxClass',Inst);
  If GetClassInfo(Inst,'LsBoxShortcut',wc) then
    UnregisterClass('LsBoxShortcut',Inst);
  If GetClassInfo(Inst,'LsBoxModule',wc) then
    UnregisterClass('LsBoxModule',Inst);
  DestroyCommandWnd;
End;

exports
  initModuleEx,
  quitModule;

end.
